diff --git a/src/main/java/net/minecraft/core/block/BlockSaplingEucalyptus.java b/src/main/java/net/minecraft/core/block/SaplingEucalyptusBlock.java
similarity index 59%
rename from src/main/java/net/minecraft/core/block/BlockSaplingEucalyptus.java
rename to src/main/java/net/minecraft/core/block/SaplingEucalyptusBlock.java
index 820e873e7..58c267aa6 100644
--- a/src/main/java/net/minecraft/core/block/BlockSaplingEucalyptus.java
+++ b/src/main/java/net/minecraft/core/block/SaplingEucalyptusBlock.java
@@ -7,15 +7,15 @@ import net.minecraft.core.world.generate.feature.WorldFeature;
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            BlockFlower, World, WorldGenTaiga2, WorldGenForest, 
+//            FlowerBlock, World, WorldGenTaiga2, WorldGenForest,
 //            WorldGenTrees, WorldGenBigTree, WorldGenerator
 
-public class BlockSaplingEucalyptus extends BlockSaplingBase
+public class SaplingEucalyptusBlock extends SaplingBaseBlock
 {
 
-	public BlockSaplingEucalyptus(String key, int id)
+	public SaplingEucalyptusBlock(String key, String namespaceId, int id)
     {
-        super(key, id);
+        super(key, namespaceId, id);
     }
     
     @Override
@@ -25,9 +25,9 @@ public class BlockSaplingEucalyptus extends BlockSaplingBase
         
     	world.setBlock(i, j, k, 0);
         
-        obj = new WorldFeatureTreeEucalyptus(Block.leavesEucalyptus.id, Block.logEucalyptus.id);
-        obj.func_517_a(1.0D, 1.0D, 1.0D);
-        if(!obj.generate(world, random, i, j, k))
+        obj = new WorldFeatureTreeEucalyptus(Blocks.LEAVES_EUCALYPTUS.id, Blocks.LOG_EUCALYPTUS.id);
+        obj.init(1.0D, 1.0D, 1.0D);
+        if(!obj.place(world, random, i, j, k))
         {
             world.setBlock(i, j, k, id);
         }
diff --git a/src/main/java/net/minecraft/core/block/SaplingOakBlock.java b/src/main/java/net/minecraft/core/block/SaplingOakBlock.java
new file mode 100644
index 000000000..a4b0410c2
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/SaplingOakBlock.java
@@ -0,0 +1,36 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
+import net.minecraft.core.world.generate.feature.WorldFeature;
+
+import java.util.Random;
+
+// Referenced classes of package net.minecraft.src:
+//            FlowerBlock, World, WorldGenTaiga2, WorldGenForest,
+//            WorldGenTrees, WorldGenBigTree, WorldGenerator
+
+public class SaplingOakBlock extends SaplingBaseBlock
+{
+
+	public SaplingOakBlock(String key, String namespaceId, int id)
+    {
+        super(key, namespaceId, id);
+    }
+    
+    @Override
+	public void growTree(World world, int i, int j, int k, Random random)
+    {
+    	Object treeBig = new WorldFeatureTreeFancy(Blocks.LEAVES_OAK.id, Blocks.LOG_OAK.id);
+        Object treeSmall = new WorldFeatureTree(Blocks.LEAVES_OAK.id, Blocks.LOG_OAK.id, 4);
+    	world.setBlock(i, j, k, 0);
+
+        if(!((WorldFeature) (treeSmall)).place(world, random, i, j, k))
+        {
+            if(!((WorldFeature) (treeBig)).place(world, random, i, j, k)) {
+                world.setBlock(i, j, k, id);
+            }
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/SaplingPalmBlock.java b/src/main/java/net/minecraft/core/block/SaplingPalmBlock.java
new file mode 100644
index 000000000..6c71d2c3c
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/SaplingPalmBlock.java
@@ -0,0 +1,23 @@
+package net.minecraft.core.block;
+
+import java.util.Random;
+
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreePalm;
+
+public class SaplingPalmBlock extends SaplingBaseBlock {
+
+	public SaplingPalmBlock(String key, String namespaceId, int id) {
+		super(key, namespaceId, id);
+		
+		this.canGrowOnSand = true;
+	}
+	
+	@Override
+	public void growTree(World world, int x, int y, int z, Random random) {
+    	boolean big = world.getBlockId(x, y - 1, z) != Blocks.SAND.id;
+    	
+    	new WorldFeatureTreePalm(Blocks.LOG_PALM, Blocks.LEAVES_PALM, big, true).place(world, random, x, y, z);
+	}
+
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockSaplingPine.java b/src/main/java/net/minecraft/core/block/SaplingPineBlock.java
similarity index 69%
rename from src/main/java/net/minecraft/core/block/BlockSaplingPine.java
rename to src/main/java/net/minecraft/core/block/SaplingPineBlock.java
index 6caa6fa5f..dec0a43db 100644
--- a/src/main/java/net/minecraft/core/block/BlockSaplingPine.java
+++ b/src/main/java/net/minecraft/core/block/SaplingPineBlock.java
@@ -8,15 +8,15 @@ import net.minecraft.core.world.generate.feature.WorldFeature;
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            BlockFlower, World, WorldGenTaiga2, WorldGenForest, 
+//            FlowerBlock, World, WorldGenTaiga2, WorldGenForest,
 //            WorldGenTrees, WorldGenBigTree, WorldGenerator
 
-public class BlockSaplingPine extends BlockSaplingBase
+public class SaplingPineBlock extends SaplingBaseBlock
 {
 
-	public BlockSaplingPine(String key, int id)
+	public SaplingPineBlock(String key, String namespaceId, int id)
     {
-        super(key, id);
+        super(key, namespaceId, id);
     }
 
     @Override
@@ -44,14 +44,14 @@ public class BlockSaplingPine extends BlockSaplingBase
     @Override
 	public void growTree(World world, int i, int j, int k, Random random)
     {
-        Object treeBig  = new WorldFeatureTreeTaigaTall(Block.leavesPine.id, Block.logPine.id);
-        Object treeSmall = new WorldFeatureTreeTaigaBushy(Block.leavesPine.id, Block.logPine.id);
+        Object treeBig  = new WorldFeatureTreeTaigaTall(Blocks.LEAVES_PINE.id, Blocks.LOG_PINE.id);
+        Object treeSmall = new WorldFeatureTreeTaigaBushy(Blocks.LEAVES_PINE.id, Blocks.LOG_PINE.id);
         
     	world.setBlock(i, j, k, 0);
 
-        if(!((WorldFeature) (treeSmall)).generate(world, random, i, j, k))
+        if(!((WorldFeature) (treeSmall)).place(world, random, i, j, k))
         {
-            if(!((WorldFeature) (treeBig)).generate(world, random, i, j, k)) {
+            if(!((WorldFeature) (treeBig)).place(world, random, i, j, k)) {
                 world.setBlock(i, j, k, id);
             }
         }
diff --git a/src/main/java/net/minecraft/core/block/BlockSaplingRetro.java b/src/main/java/net/minecraft/core/block/SaplingRetroBlock.java
similarity index 53%
rename from src/main/java/net/minecraft/core/block/BlockSaplingRetro.java
rename to src/main/java/net/minecraft/core/block/SaplingRetroBlock.java
index ff857b08b..c4ac5780e 100644
--- a/src/main/java/net/minecraft/core/block/BlockSaplingRetro.java
+++ b/src/main/java/net/minecraft/core/block/SaplingRetroBlock.java
@@ -8,28 +8,28 @@ import net.minecraft.core.world.generate.feature.WorldFeature;
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            BlockFlower, World, WorldGenTaiga2, WorldGenForest, 
+//            FlowerBlock, World, WorldGenTaiga2, WorldGenForest,
 //            WorldGenTrees, WorldGenBigTree, WorldGenerator
 
-public class BlockSaplingRetro extends BlockSaplingBase
+public class SaplingRetroBlock extends SaplingBaseBlock
 {
 
-	public BlockSaplingRetro(String key, int id)
+	public SaplingRetroBlock(String key, String namespaceId, int id)
     {
-        super(key, id);
+        super(key, namespaceId, id);
     }
 
 
     @Override
 	public void growTree(World world, int i, int j, int k, Random random)
     {
-        Object treeBig  = new WorldFeatureTreeFancy(Block.leavesOakRetro.id, Block.logOak.id);
-        Object treeSmall = new WorldFeatureTree(Block.leavesOakRetro.id, Block.logOak.id, 4);
+        Object treeBig  = new WorldFeatureTreeFancy(Blocks.LEAVES_OAK_RETRO.id, Blocks.LOG_OAK.id);
+        Object treeSmall = new WorldFeatureTree(Blocks.LEAVES_OAK_RETRO.id, Blocks.LOG_OAK.id, 4);
         world.setBlock(i, j, k, 0);
 
-        if(!((WorldFeature) (treeSmall)).generate(world, random, i, j, k))
+        if(!((WorldFeature) (treeSmall)).place(world, random, i, j, k))
         {
-            if(!((WorldFeature) (treeBig)).generate(world, random, i, j, k)) {
+            if(!((WorldFeature) (treeBig)).place(world, random, i, j, k)) {
                 world.setBlock(i, j, k, id);
             }
         }
diff --git a/src/main/java/net/minecraft/core/block/BlockSaplingShrub.java b/src/main/java/net/minecraft/core/block/SaplingShrubBlock.java
similarity index 62%
rename from src/main/java/net/minecraft/core/block/BlockSaplingShrub.java
rename to src/main/java/net/minecraft/core/block/SaplingShrubBlock.java
index 6eab4f4ed..ff81de64a 100644
--- a/src/main/java/net/minecraft/core/block/BlockSaplingShrub.java
+++ b/src/main/java/net/minecraft/core/block/SaplingShrubBlock.java
@@ -7,15 +7,15 @@ import net.minecraft.core.world.generate.feature.WorldFeature;
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            BlockFlower, World, WorldGenTaiga2, WorldGenForest, 
+//            FlowerBlock, World, WorldGenTaiga2, WorldGenForest,
 //            WorldGenTrees, WorldGenBigTree, WorldGenerator
 
-public class BlockSaplingShrub extends BlockSaplingBase
+public class SaplingShrubBlock extends SaplingBaseBlock
 {
 
-	public BlockSaplingShrub(String key, int id)
+	public SaplingShrubBlock(String key, String namespaceId, int id)
     {
-        super(key, id);
+        super(key, namespaceId, id);
     }
     
     @Override
@@ -25,9 +25,9 @@ public class BlockSaplingShrub extends BlockSaplingBase
         
     	world.setBlock(i, j, k, 0);
         
-    	obj = new WorldFeatureTreeShrub(Block.leavesShrub.id, Block.logOak.id);
+    	obj = new WorldFeatureTreeShrub(Blocks.LEAVES_SHRUB.id, Blocks.LOG_OAK.id);
         
-        if(!((WorldFeature) (obj)).generate(world, random, i, j, k))
+        if(!((WorldFeature) (obj)).place(world, random, i, j, k))
         {
             world.setBlock(i, j, k, id);
         }
diff --git a/src/main/java/net/minecraft/core/block/BlockSaplingThorn.java b/src/main/java/net/minecraft/core/block/SaplingThornBlock.java
similarity index 60%
rename from src/main/java/net/minecraft/core/block/BlockSaplingThorn.java
rename to src/main/java/net/minecraft/core/block/SaplingThornBlock.java
index a0006e8ed..3eb007099 100644
--- a/src/main/java/net/minecraft/core/block/BlockSaplingThorn.java
+++ b/src/main/java/net/minecraft/core/block/SaplingThornBlock.java
@@ -6,12 +6,12 @@ import net.minecraft.core.world.generate.feature.WorldFeature;
 
 import java.util.Random;
 
-public class BlockSaplingThorn extends BlockSaplingBase
+public class SaplingThornBlock extends SaplingBaseBlock
 {
 
-    public BlockSaplingThorn(String key, int id)
+    public SaplingThornBlock(String key, String namespaceId, int id)
     {
-        super(key, id);
+        super(key, namespaceId, id);
     }
 
 
@@ -21,9 +21,9 @@ public class BlockSaplingThorn extends BlockSaplingBase
         WorldFeature treeFeature = null;
 
         world.setBlock(x, y, z, 0);
-        treeFeature = new WorldFeatureTreeThorn(1, Block.logThorn.id, 0, Block.leavesThorn.id, 0);
+        treeFeature = new WorldFeatureTreeThorn(1, Blocks.LOG_THORN.id, 0, Blocks.LEAVES_THORN.id, 0);
 
-        if(!treeFeature.generate(world, random, x, y, z))
+        if(!treeFeature.place(world, random, x, y, z))
         {
             world.setBlock(x, y, z, id);
         }
diff --git a/src/main/java/net/minecraft/core/block/BlockGrassScorched.java b/src/main/java/net/minecraft/core/block/ScorchedGrassBlock.java
similarity index 57%
rename from src/main/java/net/minecraft/core/block/BlockGrassScorched.java
rename to src/main/java/net/minecraft/core/block/ScorchedGrassBlock.java
index 9db9d555d..de5039780 100644
--- a/src/main/java/net/minecraft/core/block/BlockGrassScorched.java
+++ b/src/main/java/net/minecraft/core/block/ScorchedGrassBlock.java
@@ -1,20 +1,20 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
-public class BlockGrassScorched extends Block
+public class ScorchedGrassBlock extends Block
 {
-    public BlockGrassScorched(String key, int id, Material material)
+    public ScorchedGrassBlock(String key, String namespaceId, int id, Material material)
     {
-        super(key, id, material);
+        super(key, namespaceId, id, material);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
@@ -22,7 +22,7 @@ public class BlockGrassScorched extends Block
             case SILK_TOUCH:
                 return new ItemStack[] { new ItemStack(this) };
             default:
-                return new ItemStack[] { new ItemStack(Block.dirtScorched) };
+                return new ItemStack[] { new ItemStack(Blocks.DIRT_SCORCHED) };
         }
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockSeat.java b/src/main/java/net/minecraft/core/block/SeatBlock.java
similarity index 60%
rename from src/main/java/net/minecraft/core/block/BlockSeat.java
rename to src/main/java/net/minecraft/core/block/SeatBlock.java
index c6141a2fa..55fb71954 100644
--- a/src/main/java/net/minecraft/core/block/BlockSeat.java
+++ b/src/main/java/net/minecraft/core/block/SeatBlock.java
@@ -1,31 +1,31 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntitySeat;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.SeatBlockEntity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class BlockSeat
-    extends BlockTileEntity
+public class SeatBlock
+    extends EntityBlock
 {
-    public BlockSeat(String key, int id) {
-        super(key, id, Material.wood);
+    public SeatBlock(String key, String namespaceId, int id) {
+        super(key, namespaceId, id, Material.wood);
         
         setBlockBounds(0f, 0f, 0f, 1f, 9f / 16f, 1f);
     }
 
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced) {
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced) {
         if (world.isBlockNormalCube(x, y + 1, z)) {
             return false;
         }
         if (!world.isClientSide) {
-            TileEntitySeat tileEntity = (TileEntitySeat) world.getBlockTileEntity(x, y, z);
+            SeatBlockEntity tileEntity = (SeatBlockEntity) world.getBlockEntity(x, y, z);
             if (tileEntity.getPassenger() == null) {
                 player.startRiding(tileEntity);
             }
@@ -37,7 +37,7 @@ public class BlockSeat
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data) {
         if (!world.isClientSide) {
-            TileEntitySeat tileEntity = (TileEntitySeat) world.getBlockTileEntity(x, y, z);
+            SeatBlockEntity tileEntity = (SeatBlockEntity) world.getBlockEntity(x, y, z);
             if (tileEntity.getPassenger() != null) {
                 tileEntity.ejectRider();
             }
@@ -46,7 +46,7 @@ public class BlockSeat
     }
 
     @Override
-    public boolean renderAsNormalBlock() {
+    public boolean isCubeShaped() {
         return false;
     }
 
@@ -56,15 +56,15 @@ public class BlockSeat
     }
     
     @Override
-    protected TileEntity getNewBlockEntity() {
-        return new TileEntitySeat();
+    protected BlockEntity getNewBlockEntity() {
+        return new SeatBlockEntity();
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity) {
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity) {
         if (dropCause != EnumDropCause.IMPROPER_TOOL)
         {
-            return new ItemStack[] { new ItemStack(Item.seat) };
+            return new ItemStack[] { new ItemStack(Items.SEAT) };
         }
         else return null;
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockLeavesShrub.java b/src/main/java/net/minecraft/core/block/ShrubLeavesBlock.java
similarity index 61%
rename from src/main/java/net/minecraft/core/block/BlockLeavesShrub.java
rename to src/main/java/net/minecraft/core/block/ShrubLeavesBlock.java
index 7a0bb876a..3632ad986 100644
--- a/src/main/java/net/minecraft/core/block/BlockLeavesShrub.java
+++ b/src/main/java/net/minecraft/core/block/ShrubLeavesBlock.java
@@ -6,27 +6,27 @@ import net.minecraft.core.block.material.Material;
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            BlockLeavesBase, Material, ColorizerFoliage, IBlockAccess,
-//            WorldChunkManager, World, Block, EntityPlayer,
+//            BaseLeavesBlock, Material, ColorizerFoliage, IBlockAccess,
+//            WorldChunkManager, World, Block, Player,
 //            ItemStack, Item, ItemShears, StatList,
 //            Entity
 
-public class BlockLeavesShrub extends BlockLeavesBase
+public class ShrubLeavesBlock extends BaseLeavesBlock
 {
 
-	public BlockLeavesShrub(String key, int id)
+	public ShrubLeavesBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.leaves);
+        super(key, namespaceId, id, Material.leaves);
     }
 
     @Override
     protected Block getSapling()
     {
-        return Block.saplingShrub;
+        return Blocks.SAPLING_SHRUB;
     }
 
     @Override
-	public void randomDisplayTick(World world, int x, int y, int z, Random rand)
+	public void animationTick(World world, int x, int y, int z, Random rand)
     {
         if (world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().hasFallingLeaves && rand.nextInt(40) == 0)
         {
diff --git a/src/main/java/net/minecraft/core/block/BlockSign.java b/src/main/java/net/minecraft/core/block/SignBlock.java
similarity index 70%
rename from src/main/java/net/minecraft/core/block/BlockSign.java
rename to src/main/java/net/minecraft/core/block/SignBlock.java
index c6c706203..cdcb84b7c 100644
--- a/src/main/java/net/minecraft/core/block/BlockSign.java
+++ b/src/main/java/net/minecraft/core/block/SignBlock.java
@@ -1,29 +1,25 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntitySign;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.SignBlockEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.WorldSource;
 
-// Referenced classes of package net.minecraft.src:
-//            BlockContainer, Material, IBlockAccess, TileEntity, 
-//            Item, World, AxisAlignedBB
-
-public class BlockSign extends BlockTileEntity
+public class SignBlock extends EntityBlock
 {
+    private final boolean isFreeStanding;
 
-	public BlockSign(String key, int id, Class class1, boolean flag)
+	public SignBlock(String key, String namespaceId, int id, boolean isFreeStanding)
     {
-        super(key, id, Material.wood);
-        isFreestanding = flag;
-        signEntityClass = class1;
+        super(key, namespaceId, id, Material.wood);
+        this.isFreeStanding = isFreeStanding;
         float f = 0.25F;
         float f1 = 1.0F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, f1, 0.5F + f);
@@ -45,7 +41,7 @@ public class BlockSign extends BlockTileEntity
     @Override
     public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
-        if(isFreestanding)
+        if(isFreeStanding)
         {
             return;
         }
@@ -98,7 +94,7 @@ public class BlockSign extends BlockTileEntity
     }
 
     @Override
-	public boolean renderAsNormalBlock()
+	public boolean isCubeShaped()
     {
         return false;
     }
@@ -110,23 +106,16 @@ public class BlockSign extends BlockTileEntity
     }
 
     @Override
-	protected TileEntity getNewBlockEntity()
+	protected BlockEntity getNewBlockEntity()
     {
-        try
-        {
-            return (TileEntity)signEntityClass.newInstance();
-        }
-        catch(Exception exception)
-        {
-            throw new RuntimeException(exception);
-        }
+        return new SignBlockEntity();
     }
 
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
         boolean flag = false;
-        if(isFreestanding)
+        if(isFreeStanding)
         {
             if(!world.getBlockMaterial(x, y - 1, z).isSolid())
             {
@@ -160,23 +149,28 @@ public class BlockSign extends BlockTileEntity
         }
         super.onNeighborBlockChange(world, x, y, z, blockId);
     }
-
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
-        return new ItemStack[] { new ItemStack(Item.sign) };
+        return new ItemStack[] { new ItemStack(Items.SIGN) };
     }
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced) {
-        TileEntitySign tileentitysign = (TileEntitySign)world.getBlockTileEntity(x, y, z);
-        if(tileentitysign != null && tileentitysign.getIsEditable(player))
-        {
-            player.displayGUIEditSign(tileentitysign);
-            return true;
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced) {
+        SignBlockEntity signEntity = (SignBlockEntity)world.getBlockEntity(x, y, z);
+        if (signEntity != null && player != null) {
+            if (player.getHeldItem() != null && player.getHeldItem().itemID == Items.DUST_GLOWSTONE.id && !signEntity.isGlowing()) {
+                signEntity.setGlowing(true);
+                if (player.getGamemode().consumeBlocks()) {
+                    player.getHeldItem().stackSize--;
+                }
+                return true;
+            } else if (player.getHeldItem() != null && player.getHeldItem().itemID == Items.DYE.id) {
+                return false;
+            } else if (signEntity.isEditableBy(player)) {
+                player.displayGUIEditSign(signEntity);
+                return true;
+            }
         }
         return false;
     }
-
-    private Class signEntityClass;
-    private boolean isFreestanding;
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockSlab.java b/src/main/java/net/minecraft/core/block/SlabBlock.java
similarity index 73%
rename from src/main/java/net/minecraft/core/block/BlockSlab.java
rename to src/main/java/net/minecraft/core/block/SlabBlock.java
index e04b5018a..50fb2099f 100644
--- a/src/main/java/net/minecraft/core/block/BlockSlab.java
+++ b/src/main/java/net/minecraft/core/block/SlabBlock.java
@@ -1,16 +1,17 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.material.MaterialColor;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.item.block.ItemBlockSlab;
+import net.minecraft.core.item.block.SlabBlockItem;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
@@ -19,18 +20,18 @@ import java.util.Random;
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, World, IBlockAccess
 
-public class BlockSlab extends Block
+public class SlabBlock extends Block
 {
 
-    public BlockSlab(Block modelBlock, int id)
+    public SlabBlock(Block modelBlock, String namespaceId, int id)
     {
-        this(modelBlock, id, 0);
-        setBlockItem(() -> new ItemBlockSlab(this));
+        this(modelBlock, namespaceId, id, 0);
+        setBlockItem(() -> new SlabBlockItem(this));
     }
     
-    public BlockSlab(Block modelBlock, int id, int modelBlockMetadata)
+    public SlabBlock(Block modelBlock, String namespaceId, int id, int modelBlockMetadata)
     {
-    	super("slab." + modelBlock.key.substring(5), id, modelBlock.blockMaterial);
+    	super("slab." + modelBlock.key.substring(5), namespaceId, id, modelBlock.blockMaterial);
         this.modelBlock = modelBlock;
         this.modelBlockMetadata = modelBlockMetadata;
         withHardness(modelBlock.blockHardness);
@@ -56,10 +57,10 @@ public class BlockSlab extends Block
     {
         int l = world.getBlockMetadata(x, y, z) & 0x3;
         if(l == 0)
-            return AABB.getBoundingBoxFromPool(x, y, z, x +1f, y +0.5f, z +1f);
+            return AABB.getTemporaryBB(x, y, z, x +1f, y +0.5f, z +1f);
         if(l == 1)
-            return AABB.getBoundingBoxFromPool(x, y, z, x +1, y +1f, z +1f);
-        return AABB.getBoundingBoxFromPool(x, y +0.5f, z, x +1f, y +1f, z +1f);
+            return AABB.getTemporaryBB(x, y, z, x +1, y +1f, z +1f);
+        return AABB.getTemporaryBB(x, y +0.5f, z, x +1f, y +1f, z +1f);
     }
 
     @Override
@@ -83,9 +84,9 @@ public class BlockSlab extends Block
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
-        ItemStack[] result = modelBlock.getBreakResult(world, dropCause, x, y, z, modelBlockMetadata, tileEntity);
+        ItemStack[] result = modelBlock.getBreakResult(world, dropCause, x, y, z, modelBlockMetadata, blockEntity);
 
         if (result != null)
         {
@@ -105,9 +106,9 @@ public class BlockSlab extends Block
     }
 
     @Override
-    public int tickRate()
+    public int tickDelay()
     {
-        return modelBlock.tickRate();
+        return modelBlock.tickDelay();
     }
 
     @Override
@@ -118,7 +119,7 @@ public class BlockSlab extends Block
 
 
     @Override
-    public void handleEntityInside(World world, int x, int y, int z, Entity entity, Vec3d entityVelocity)
+    public void handleEntityInside(World world, int x, int y, int z, Entity entity, Vec3 entityVelocity)
     {
         modelBlock.handleEntityInside(world, x, y, z, entity, entityVelocity);
     }
@@ -153,7 +154,7 @@ public class BlockSlab extends Block
         modelBlock.updateTick(world, x, y, z, rand);
     }
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         return modelBlock.onBlockRightClicked(world, x, y, z, player, side, xPlaced, yPlaced);
     }
@@ -164,8 +165,8 @@ public class BlockSlab extends Block
     }
 
     @Override
-    public void onBlockPlaced(World world, int x, int y, int z, Side side, EntityLiving entity, double sideHeight) {
-    	Direction dir = entity.getVerticalPlacementDirection(side, sideHeight);
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    	Direction dir = mob.getVerticalPlacementDirection(side, sideHeight);
     	if(dir == Direction.DOWN) {
             world.setBlockMetadataWithNotify(x, y, z, 0);
     	}
@@ -175,16 +176,16 @@ public class BlockSlab extends Block
     }
     
     @Override
-	public void onBlockAdded(World world, int x, int y, int z)
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
         onNeighborBlockChange(world, x, y, z, 0);
-        modelBlock.onBlockAdded(world, x, y, z);
+        modelBlock.onBlockPlacedByWorld(world, x, y, z);
     }
 
     @Override
-    public int getRenderBlockPass()
+    public int getRenderLayer()
     {
-        return modelBlock.getRenderBlockPass();
+        return modelBlock.getRenderLayer();
     }
 
     @Override
@@ -200,15 +201,19 @@ public class BlockSlab extends Block
     }
     
     @Override
-    public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit)
+    public void onBlockLeftClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit)
     {
         modelBlock.onBlockLeftClicked(world, x, y, z, player, side, xHit, yHit);
     }
 
     @Override
-	public void randomDisplayTick(World world, int x, int y, int z, Random rand)
+	public void animationTick(World world, int x, int y, int z, Random rand)
     {
-        modelBlock.randomDisplayTick(world, x, y, z, rand);
+        modelBlock.animationTick(world, x, y, z, rand);
+    }
+    @Override
+    public MaterialColor getMaterialColor(){
+        return modelBlock.getMaterialColor();
     }
 
     public Block modelBlock;
